<?php

namespace OCA\Dematpayslip\Migration;

use Closure;
use OCP\DB\ISchemaWrapper;
use OCP\Migration\SimpleMigrationStep;
use OCP\Migration\IOutput;

class Version010003Date20191115020000 extends SimpleMigrationStep {

    /**
     * @param IOutput $output
     * @param Closure $schemaClosure The `\Closure` returns a `ISchemaWrapper`
     * @param array $options
     * @return null|ISchemaWrapper
     */
    public function changeSchema(IOutput $output, Closure $schemaClosure, array $options) {
        /** @var ISchemaWrapper $schema */
        $schema = $schemaClosure();

        $table = $schema->getTable('dematpayslip_user');
        $table->addColumn('siret', 'string', [
            'notnull' => true,
            'length' => 64,
        ]);

        $table->dropIndex('dematpayslip_user_user_id');
        $table->dropIndex('dematpayslip_user_matricule');
        $table->dropIndex('dematpayslip_user_email');
        $table->addUniqueIndex(['siret', 'matricule'], 'dematpayslip_user_siret_matricule');

        return $schema;
    }
}
